# setup docker image
docker build --tag fedora-compiled:31 -f Dockerfile-31-compiled .
docker run --user user --cap-add=SYS_PTRACE -it fedora-compiled:31 bash

# compile code sample
/usr/bin/c++ -std=c++11 -Wall -Wextra -isystem /usr/include/openmpi -isystem /opt/boost/include -g -o sample.cpp.o -c sample.cpp
/usr/bin/c++ -g -Wl,--enable-new-dtags -pthread -rdynamic sample.cpp.o -o sample -Wl,-rpath=/opt/boost/lib -Wl,-rpath,/usr/lib /usr/lib/libmpi.so /opt/boost/lib/libboost_mpi.so /opt/boost/lib/libboost_serialization.so

# run binary with 2 threads to show the expected behavior
/usr/bin/mpiexec -n 2 sample

# show MPI_TAG_UB
g++ -std=c++11 -isystem /usr/include/openmpi get_tag.cpp -o get_tag -Wl,-rpath,/usr/lib /usr/lib/libmpi.so
/usr/bin/mpiexec -n 1 get_tag

