# setup docker image
docker build --tag fedora-default:31 -f Dockerfile-31-default .
docker run --user user --cap-add=SYS_PTRACE -it fedora-default:31 bash

# compile code sample
/usr/bin/c++ -std=c++11 -isystem /usr/include/openmpi-x86_64 -g -o sample.cpp.o -c sample.cpp
/usr/bin/c++ -g -Wl,--enable-new-dtags -pthread -rdynamic sample.cpp.o -o sample -Wl,-rpath,/usr/lib64/openmpi/lib /usr/lib64/openmpi/lib/libmpi_cxx.so /usr/lib64/openmpi/lib/libmpi.so /usr/lib64/openmpi/lib/libboost_mpi.so -lboost_serialization

# run binary with 2 threads to reproduce the bug
/usr/lib64/openmpi/bin/mpiexec -n 2 sample

# show MPI_TAG_UB
g++ -std=c++11 -Wall -Wextra -isystem /usr/include/openmpi-x86_64 get_tag.cpp -o get_tag -Wl,-rpath,/usr/lib64/openmpi/lib /usr/lib64/openmpi/lib/libmpi_cxx.so /usr/lib64/openmpi/lib/libmpi.so
/usr/lib64/openmpi/bin/mpiexec -n 1 get_tag

