/*
 * Boost 1.69 tutorial for boost::mpi::reduce
 * Source: https://www.boost.org/doc/libs/1_69_0/doc/html/mpi/tutorial.html#mpi.reduce
 * Copyright (C) 2005-2007 Douglas Gregor, Matthias Troyer, Trustees of Indiana University
 * Distributed under the Boost Software License, Version 1.0. (See copy at http://www.boost.org/LICENSE_1_0.txt)
 */
#include <boost/mpi.hpp>
#include <iostream>
#include <string>
#include <functional>
#include <boost/serialization/string.hpp>
namespace mpi = boost::mpi;

int main()
{
  mpi::environment env;
  mpi::communicator world;

  std::string names[10] = { "zero ", "one ", "two ", "three ",
                            "four ", "five ", "six ", "seven ",
                            "eight ", "nine " };

  std::string result;
  boost::mpi::reduce(
         world,
         world.rank() < 10? names[world.rank()]
                          : std::string("many "),
         result, std::plus<std::string>(), 0);

  if (world.rank() == 0)
    std::cout << "The result is " << result << std::endl;

  return 0;
}

